﻿/*
Created by: X
http://www.createdbyx.com/

This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 2.5 Canada License 
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/. 
Permissions beyond the scope of this license may be available at http://contact.createdbyx.com/.
*/
using SLPathfindaz;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace PathFindingExample1
{
    public partial class Game1
    {
        // stores the tiles locations along the path from start to end
        private Point[] pathPoints;
        // hold the object reference responcible for path finding
        private SLPathfindaz.PathFinder finder;

        /// <summary>
        /// Draws the path from start to end if there is one
        /// </summary>
        public void DrawPath()
        {
            if (this.pathPoints == null) return;
            foreach (Point point in pathPoints)
            {
                this.lineDrawer.FillRectange(point.X * this.cellSize, point.Y * this.cellSize, this.cellSize, this.cellSize, Color.Purple);
            }
        }

        /// <summary>
        /// Solves the path
        /// </summary>
        private void SolvePath()
        {
            // if start and end positions are the same we can exit
            if (this.startPosition == this.endPosition) return;
            // create  the finder is not already created
            if (finder == null) this.finder = new PathFinder(this.grid);

            this.pathPoints = finder.GetPath(this.startPosition, this.endPosition);
        }
    }
}
