/*
Created by: X
http://www.createdbyx.com/

This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 2.5 Canada License 
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/. 
Permissions beyond the scope of this license may be available at http://contact.createdbyx.com/.
*/
using System;
using Microsoft.Xna.Framework;


namespace PathFindingExample1
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public class GridComponent : Microsoft.Xna.Framework.DrawableGameComponent ,SLPathfindaz.IMap
    {

        private bool[,] cells;

        public int GridWidth
        {
            get { return this.cells.GetUpperBound(0)+1; }
        }

        public int GridHeight
        {
            get { return this.cells.GetUpperBound(1)+1; }
        }

        public bool GetCell(int x, int y)
        {
            return this.cells[x, y];
        }

        public void SetCell(int x, int y, bool value)
        {
            this.cells[x, y] = value;
        }

        public GridComponent(Game game, int width, int height)
            : base(game)
        {
            this.cells = new bool[width, height];
        }
        
        public void RandomizeGrid()
        {
            Random rand = new Random((int) DateTime.Now.Ticks);
            for (int idx = 0; idx <= this.cells.GetUpperBound(0); idx++)
            {
                for (int idy = 0; idy <= this.cells.GetUpperBound(1); idy++)
                {
                    this.cells[idx, idy] = rand.Next(1000) > 500 ? true : false;
                }
            }
        }
        
        public int Width
        {
            get { return this.GridWidth; }
        }

        public int Height
        {
            get { return this.GridHeight; }
        }

        public bool IsTileClear(Point tile)
        {
            return !this.cells[tile.X, tile.Y];
        }

        public bool IsTileClear(int x, int y)
        {
            return !this.cells[x, y];
        }
    }
}