/*
Created by: X
http://www.createdbyx.com/

SLPathfindaz is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/

Special thanks to SwampThingTom from which the code in this library was originally written.
 
SwampThingTom@bayougames.com
http://www.bayougames.com/
Link to the Pathfinding Sample Using A* article and sample xna project
http://swampthingtom.blogspot.com/2007/07/pathfinding-sample-using.html
Related A* pathfinding article
http://www.policyalmanac.org/games/aStarTutorial.htm

Original Copyright header can be found in tehe OriginalLicenseHeader.txt file
    */

using Microsoft.Xna.Framework;

namespace SLPathfindaz
{
        /// <summary>
    /// Interface for pathfinding on a map.
    /// Defines a map that is divided into tiles.  A tile marked as Clear is
    /// unobstructed and can be used by the Pathfinder for creating a Path.
    /// </summary>
    public interface IMap
    {
        /// <summary>
        /// Width of map in tiles.
        /// </summary>
        int Width { get; }

        /// <summary>
        /// Height of map in tiles.
        /// </summary>
        int Height { get; }

        /// <summary>
        /// Determines whether map tile can be entered.
        /// </summary>
        /// <param name="tile">Map tile</param>
        /// <returns>True if map tile can be entered</returns>
        bool IsTileClear(Point tile);

        /// <summary>
        /// Determines whether map tile can be entered.
        /// </summary>
        /// <param name="x">Map tile x position</param>
        /// <param name="y">Map tile y position</param>
        /// <returns>True if map tile can be entered</returns>
        bool IsTileClear(int x, int y);
    }
}