﻿/*
Created by: X
http://www.createdbyx.com/

SLPathfindaz is licenced under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/

Special thanks to SwampThingTom from which the code in this library was originally written.
 
SwampThingTom@bayougames.com
http://www.bayougames.com/
Link to the Pathfinding Sample Using A* article and sample xna project
http://swampthingtom.blogspot.com/2007/07/pathfinding-sample-using.html
Related A* pathfinding article
http://www.policyalmanac.org/games/aStarTutorial.htm

Original Copyright header can be found in tehe OriginalLicenseHeader.txt file
    */
using System.Collections.Generic;

namespace SLPathfindaz
{
    public class OpenList : List<PathNode>
    {
        #region Open Node List
        /// <summary>
        /// Creates the Open Node List.
        /// </summary>
        public OpenList()
        {
        }

        /// <summary>
        /// Returns the node that appears to have the lowest cost for
        /// getting to the destination.  This also removes it from the
        /// Open List and sets its status to Closed.
        /// </summary>
        /// <returns></returns>
        public PathNode GetBestOpenNode()
        {
            if (this.Count == 0)
            {
                return null;
            }

            this.Sort();
            PathNode node = this[0];
            this.RemoveAt(0);
            node.Status = NodeStatus.Closed;
            return node;
        }

        #endregion
    }
}
